#property link "https://t.me/fxsaberDiscussion"

#include <MT4Orders.mqh> // https://www.mql5.com/ru/code/16006

#define MAGIC 123454321
#define Bid SymbolInfoDouble(_Symbol, SYMBOL_BID)
#define Ask SymbolInfoDouble(_Symbol, SYMBOL_ASK)

input int inHours = 24;
input int inStep = 60; // Step in seconds

bool OrderScan( const int Type, const MAGIC_TYPE Magic = MAGIC )
{
  bool Res = false;

  for (int i = OrdersTotal() - 1; !Res && (i >= 0); i--)
    Res = OrderSelect(i, SELECT_BY_POS) &&  (OrderType() == Type) && (OrderMagicNumber() == Magic) && (OrderSymbol() == _Symbol);

  return(Res);
}

datetime GetLastDealTime( const MAGIC_TYPE Magic = MAGIC )
{
  bool Res = false;

  for (int i = OrdersHistoryTotal() - 1; !Res && (i >= 0); i--)
    Res = OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) &&  (OrderType() <= OP_SELL) && (OrderMagicNumber() == Magic) && (OrderSymbol() == _Symbol);

  return(Res ? OrderCloseTime() : 0);
}

int OnInit()
{
  MT4ORDERS::OrderSend_MaxPause = 10000000;

  if (!OrderScan(OP_BUY) && !OrderScan(OP_SELL))
  {
    const double Lot = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_MIN) +
                                       SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_MIN) * (inHours * 3600 / (inStep * 2)), _Digits);

    OrderSend(_Symbol, OP_BUY, Lot, Ask, 0, 0, 0, "Research", MAGIC);
    OrderSend(_Symbol, OP_SELL, Lot, Bid, 0, 0, 0, "Research", MAGIC);
  }

  return(!EventSetTimer(1));
}

void OnTimer()
{
  static const double LotMin = SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_MIN);
  static uint StartTime = GetTickCount();

  const datetime PrevTime = GetLastDealTime();
  const datetime NextTime = (PrevTime / inStep + 1) * inStep;

  const uint NewTime = GetTickCount();

  if (PrevTime + (NewTime - StartTime) / 1000 >= NextTime)
  {
    const double LotBuy = OrderScan(OP_BUY) ? OrderLots() : 0;
    const double LotSell = OrderScan(OP_SELL) ? OrderLots() : 0;

    if ((LotBuy || LotSell) && OrderScan(LotBuy < LotSell) &&
        OrderClose(OrderTicket(), LotMin, OrderClosePrice(), 100))
    {
      const datetime NewLastDealTime = GetLastDealTime();

      StartTime = (NewLastDealTime != PrevTime) ? NewTime : StartTime;
    }
  }
}